package com.liang.dao;

import com.liang.entity.BaseProjectbudget;
import com.liang.entity.PrjBudget;
import com.liang.entity.PrjBudgetRecord;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.math.BigDecimal;
import java.util.List;

/**
 * 项目预算(PrjBudget)表数据库访问层
 *
 * @author makejava
 * @since 2023-03-10 07:49:56
 */
public interface PrjBudgetDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    PrjBudget queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param prjBudget 查询条件
     * @param pageable  分页对象
     * @return 对象列表
     */
    List<PrjBudget> queryAllByLimit(PrjBudget prjBudget, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param prjBudget 查询条件
     * @return 总行数
     */
    long count(PrjBudget prjBudget);

    /**
     * 新增数据
     *
     * @param prjBudget 实例对象
     * @return 影响行数
     */
    int insert(PrjBudget prjBudget);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<PrjBudget> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<BaseProjectbudget> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<PrjBudget> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<PrjBudget> entities);

    /**
     * 修改数据
     *
     * @param prjBudget 实例对象
     * @return 影响行数
     */
    int update(PrjBudget prjBudget);

    /**
     * 完成单位数量
     *
     * @param count
     * @return
     */
    int updateYsByXm(Integer xm, Integer count);

    int updateYSYE(Integer xm);

    int emptyYSYE(Integer xm);

    /**
     * 更新预算
     *
     * @param entities
     * @return
     */
    int updateBatch(@Param("entities") List<PrjBudget> entities);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 删除项目预算
     *
     * @param xm
     * @return
     */
    int deleteByXm(Integer xm);

    /**
     * 批量删除项目预算
     *
     * @return
     */
    int batchDeleteByXm(List<Integer> xmList);

    /**
     * 获取预算列表
     *
     * @return
     */
    List<PrjBudget> getBudgetList(Integer xm);

    BigDecimal queryYSJEByXMAndZJ(Integer id);

    int updateXG(@Param("record") PrjBudgetRecord budget);

    void updateSPTGZT(@Param("sptgzt") String xg,@Param("mc") String mc, @Param("xm") Integer xm);

    List<PrjBudget> getOldBudgetList(Integer xm);
}

